<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
package ${pub.getPKGCodeName()}.util.client;

import com.alibaba.fastjson.JSONObject;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import java.util.Map;

@FeignClient(value = "${r'${ibiz.ref.service.lite:ibzlite-api}'}",contextId = "lite",fallback = IBZLiteFallback.class)
public interface IBZLiteFeignClient
{
	/**
	 * 同步系统资模型到lite
	 * @param system 系统模型信息
	 * @return
	 */
	@PostMapping("/lite/syncsysmodel")
	Boolean syncSysModel(@RequestBody JSONObject system);

	<#if pub.isEnableDynaModel()?? && pub.isEnableDynaModel()== true>
	/**
	 * 获取动态模型
	 * @param systemId
	 * @return
	 */
	@RequestMapping(method = RequestMethod.GET, value = "/lite/{systemid}/getdynamicmodel")
	List<Map<String, Object>> getDynamicModel(@PathVariable("systemid") String systemId);
	</#if>
}
