<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<#assign oauth2Enable=false>
<#if sysrun?? && sysrun.getPSDevSlnMSDepAPI()?? >
    <#assign depSysApi=sysrun.getPSDevSlnMSDepAPI()>
    <#if depSysApi.getPSDCMSPlatformNode()??>
        <#assign depSysApiPlatformNode=depSysApi.getPSDCMSPlatformNode()>
        <#assign depSysApiPlatform=depSysApi.getPSDCMSPlatform()>
        <#if depSysApiPlatform.getUserParam("ibiz.oauth2.enable","")?? && depSysApiPlatform.getUserParam("ibiz.oauth2.enable","")!="">
            <#assign oauth2Enable=true>
        </#if>
    </#if>
</#if>
package ${pub.getPKGCodeName()}.util.web;

import feign.RequestInterceptor;
import feign.RequestTemplate;
import net.ibizsys.sample.mng.util.client.IBZUAAFeignClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.util.ObjectUtils;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.Enumeration;
import java.util.LinkedHashMap;

/**
 * feign请求拦截器
 * 拦截所有使用feign发出的请求，附加原始请求Header参数及Token
 */
@Configuration
public class FeignRequestInterceptor implements RequestInterceptor {

    private final Logger logger = LoggerFactory.getLogger(getClass());

<#if oauth2Enable>
    @Autowired
    IBZUAAFeignClient ibzuaaFeignClient;

    @Value("${r'${ibiz.oauth2.grantType:client_credentials}'}")
    private String grantType;

    @Value("${r'${ibiz.oauth2.clientId:test}'}")
    private String clientId;

    @Value("${r'${ibiz.oauth2.clientSecret:test}'}")
    private String clientSecret;

    @Value("${r'${ibiz.oauth2.header:accesstoken}'}")
    private String oauth2Authorization;
</#if>

    @Override
    public void apply(RequestTemplate requestTemplate) {
        ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        <#if oauth2Enable>
        if(requestTemplate.path().matches("/oauth/token")){
            return;
        }
        </#if>
        if (requestAttributes != null) {
            HttpServletRequest request = requestAttributes.getRequest();
            Enumeration<String> headerNames = request.getHeaderNames();
            if (headerNames != null) {
                while (headerNames.hasMoreElements()) {
                    String name = headerNames.nextElement();
                    if (name.equalsIgnoreCase("transfer-encoding")) {
                        continue;
                    }
                    String values = request.getHeader(name);
                    requestTemplate.header(name, values);
                }
                <#if oauth2Enable>
                if(ObjectUtils.isEmpty(request.getHeader(oauth2Authorization))){
                    MultiValueMap<String, String> postParameters = new LinkedMultiValueMap<>();
                    postParameters.add("client_id", clientId);
                    postParameters.add("client_secret", clientSecret);
                    postParameters.add("grant_type", grantType);
                    LinkedHashMap<String,String> token = (LinkedHashMap<String, String>)ibzuaaFeignClient.getToken(postParameters);
                    if(!ObjectUtils.isEmpty(token.get("access_token"))){
                        requestTemplate.header(oauth2Authorization, "Bearer "+token.get("access_token"));
                    }
                }
                </#if>
                logger.info("feign interceptor header:{}", requestTemplate);
            }
        }
    }
}